//////////////////////////////////////////////////////////////////////////////
//    Copyright 2004-2019, SenseGraphics AB
//
//    Any use, or distribution, of this file without permission from the
//    copyright holders is strictly prohibited. Please contact SenseGraphics,
//    www.sensegraphics.com, for more information.
//
//
/// \file H3DPhysics/StdAfx.h
/// \brief Header file for precompiled headers.
///
//////////////////////////////////////////////////////////////////////////////

#ifndef __H3D_H3DPHYSICS_STDAFX__
#define __H3D_H3DPHYSICS_STDAFX__

#include <GL/glew.h>
#include <Windows.h>

#include <H3D/PeriodicUpdate.h>
#include <H3D/DependentNodeFields.h>
#include <H3D/FieldTemplates.h>
#include <H3D/TypedField.h>
#include <H3D/TypedFieldAnyTmpl.h>
#include <H3D/TypedFieldCheck.h>
#include <H3D/TypedFieldTypesTmpl.h>

#include <H3D/MFNodeAutoRefVector.h>
#include <H3D/X3DNode.h>

#include <H3D/SFBool.h>
#include <H3D/SFColor.h>
#include <H3D/SFColorRGBA.h>
#include <H3D/SFDouble.h>
#include <H3D/SFFloat.h>
#include <H3D/SFInt32.h>
#include <H3D/SFMatrix3d.h>
#include <H3D/SFMatrix3f.h>
#include <H3D/SFMatrix4d.h>
#include <H3D/SFMatrix4f.h>
#include <H3D/SFNode.h>
#include <H3D/SFQuaternion.h>
#include <H3D/SFRotation.h>
#include <H3D/SFString.h>
#include <H3D/SFTime.h>
#include <H3D/SFVec2d.h>
#include <H3D/SFVec2f.h>
#include <H3D/SFVec3d.h>
#include <H3D/SFVec3f.h>
#include <H3D/SFVec4d.h>
#include <H3D/SFVec4f.h>


#include <H3D/MFBool.h>
#include <H3D/MFColor.h>
#include <H3D/MFColorRGBA.h>
#include <H3D/MFDouble.h>
#include <H3D/MFFloat.h>
#include <H3D/MFInt32.h>
#include <H3D/MFMatrix3d.h>
#include <H3D/MFMatrix3f.h>
#include <H3D/MFMatrix4d.h>
#include <H3D/MFMatrix4f.h>
#include <H3D/MFNode.h>
#include <H3D/MFQuaternion.h>
#include <H3D/MFRotation.h>
#include <H3D/MFString.h>
#include <H3D/MFTime.h>
#include <H3D/MFVec2d.h>
#include <H3D/MFVec2f.h>
#include <H3D/MFVec3d.h>
#include <H3D/MFVec3f.h>
#include <H3D/MFVec4d.h>
#include <H3D/MFVec4f.h>

#endif